//+------------------------------------------------------------------+
//|                                   Double Smoothed Stochastic.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  Green
#property indicator_color2  Orange
#property indicator_color3  Orange
#property indicator_color4  Blue
#property indicator_color5  Red
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_level1  20
#property indicator_level2  50
#property indicator_level3  80
#property indicator_levelcolor DarkSlateGray

//
//
//
//
//

extern int StochasticPeriod = 55;
extern int EMAPeriod        = 15;
extern bool AlertOn=false;

//
//
//
//
//

double upBuffera[];
double dnBuffera[];
double dnBufferb[];
double wrBuffera[];
double uparrow[],dwarrow[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0, upBuffera);
   SetIndexBuffer(1, dnBuffera);
   SetIndexBuffer(2, dnBufferb);
    SetIndexBuffer(3, uparrow);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,241);
   SetIndexBuffer(4, dwarrow);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,242);
   SetIndexBuffer(5, wrBuffera);
   
   IndicatorShortName("Double smoothed stochastic "+StochasticPeriod+","+EMAPeriod+")");
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   double max,min,sto;
   double alpha = 2.0/(1.0+EMAPeriod);
   int    counted_bars=IndicatorCounted();
   int    i,limit;


   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars - counted_bars,Bars-1);

   //
   //
   //
   //
   //

      if (upBuffera[limit] < upBuffera[limit+1]) CleanPoint(limit,dnBuffera,dnBufferb);

   //
   //
   //
   //
   //
         
      for(i = limit; i >= 0 ; i--)
      {
         max = High[ArrayMaximum(High,StochasticPeriod,i)];
         min =  Low[ArrayMinimum( Low,StochasticPeriod,i)];
         if (max!=min)
               sto = (Close[i]-min)/(max-min)*100.00;
         else  sto = 0;            
         wrBuffera[i] = wrBuffera[i+1]+alpha*(sto-wrBuffera[i+1]);
      
         //
         //
         //
         //
         //
      
         max = wrBuffera[ArrayMaximum(wrBuffera,StochasticPeriod,i)];
         min = wrBuffera[ArrayMinimum(wrBuffera,StochasticPeriod,i)];
         if (max!=min)
               sto = (wrBuffera[i]-min)/(max-min)*100.00;
         else  sto = 0;            
         upBuffera[i] = upBuffera[i+1]+alpha*(sto-upBuffera[i+1]);

         
         //
         //
         //
         //
         //
         //

         dnBuffera[i] = EMPTY_VALUE;
         dnBufferb[i] = EMPTY_VALUE;
         if (upBuffera[i] < upBuffera[i+1]) {
             if(dnBuffera[i+1]==EMPTY_VALUE) {
               dwarrow[i]=upBuffera[i];
               if(AlertOn) Alert("Sell Signal");
             }
             PlotPoint(i,dnBuffera,dnBufferb,upBuffera);
         }
        
         if((dnBuffera[i+1]!=EMPTY_VALUE || dnBufferb[i+1]!=EMPTY_VALUE) &&(dnBuffera[i]==EMPTY_VALUE && dnBufferb[i]==EMPTY_VALUE)){
            uparrow[i]=upBuffera[i];
            if(AlertOn) Alert("Buy Signal");
         }
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

